﻿// code is Copyright (c) 2008 Julian M Bucknall, www.boyet.com
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


namespace RedBlackTrees {
  public partial class TreePainterApp : Form {
    private SimpleNode root;

    public TreePainterApp() {
      InitializeComponent();
    }

    private void btnSave_Click(object sender, EventArgs e) {
      // nothing yet
    }

    private void button1_Click(object sender, EventArgs e) {
      panel2.Invalidate();
    }

    private void PaintPanel(Graphics g) {
      float unit = 30.0f;
      g.ScaleTransform(unit, unit);
      GridLines.Draw(g, panel2.Width, panel2.Height, unit);

      g.TranslateTransform(1.0f, 1.0f);
      using (SimpleNodePainter nodePainter = new SimpleNodePainter(g, unit)) {
        TreePainter painter = new TreePainter(nodePainter);
        painter.DrawTree(root);
      }
    }
    private void panel2_Paint(object sender, PaintEventArgs e) {
      PaintPanel(e.Graphics);
    }

    private void TreePainterApp_Load(object sender, EventArgs e)
    {
      root = new SimpleNode();
      root.Left = new SimpleNode();
      root.Left.Left = new SimpleNode();
      root.Left.Left.Right = new SimpleNode();
      root.Right = new SimpleNode();
      root.Right.Right = new SimpleNode();
      root.Right.Left = new SimpleNode();
      root.Right.Left.Left = new SimpleNode();
    }
  }
}